from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import String, Int, Directory, Float

Basenji_Data_Align_Py_V0_1_0 = CommandToolBuilder(tool="basenji_data_align.py", base_command=["basenji_data_align.py"], inputs=[ToolInput(tag="in_genome_labels_output", input_type=String(optional=True), prefix="-a", doc=InputDocumentation(doc="Genome labels in output")), ToolInput(tag="in_break", input_type=Int(optional=True), prefix="--break", doc=InputDocumentation(doc="Break in half contigs above length [Default: none]")), ToolInput(tag="in_crop", input_type=Int(optional=True), prefix="--crop", doc=InputDocumentation(doc="Crop bp off each end [Default: 0]")), ToolInput(tag="in_downsample_the_segments", input_type=String(optional=True), prefix="-d", doc=InputDocumentation(doc="Down-sample the segments")), ToolInput(tag="in_generate_cross_split", input_type=String(optional=True), prefix="-f", doc=InputDocumentation(doc="Generate cross fold split [Default: none]")), ToolInput(tag="in_commaseparated_list_files", input_type=String(optional=True), prefix="-g", doc=InputDocumentation(doc="Comma-separated list of assembly gaps BED files\n[Default: none]")), ToolInput(tag="in_sequence_length", input_type=Int(optional=True), prefix="-l", doc=InputDocumentation(doc="Sequence length [Default: 131072]")), ToolInput(tag="in_nf", input_type=Int(optional=True), prefix="--nf", doc=InputDocumentation(doc="Alignment net fill size minimum [Default: 100000]")), ToolInput(tag="in_no", input_type=Int(optional=True), prefix="--no", doc=InputDocumentation(doc="Alignment net and contig overlap minimum [Default:\n1024]")), ToolInput(tag="in_output_directory", input_type=Directory(optional=True), prefix="-o", doc=InputDocumentation(doc="Output directory [Default: align_out]")), ToolInput(tag="in_seed", input_type=Int(optional=True), prefix="--seed", doc=InputDocumentation(doc="Random seed [Default: 44]")), ToolInput(tag="in_snap", input_type=Int(optional=True), prefix="--snap", doc=InputDocumentation(doc="Snap sequences to multiple of the given value\n[Default: 1]")), ToolInput(tag="in_stride_train", input_type=String(optional=True), prefix="--stride_train", doc=InputDocumentation(doc="Stride to advance train sequences [Default:\nseq_length]")), ToolInput(tag="in_stride_test", input_type=Float(optional=True), prefix="--stride_test", doc=InputDocumentation(doc="Stride to advance valid and test sequences [Default:\n1.0]")), ToolInput(tag="in_proportion_data_testing", input_type=Float(optional=True), prefix="-t", doc=InputDocumentation(doc="Proportion of the data for testing [Default: 0.1]")), ToolInput(tag="in_commaseparated_genome_segments", input_type=String(optional=True), prefix="-u", doc=InputDocumentation(doc="Comma-separated genome unmappable segments to set to")), ToolInput(tag="in_sum_pool_width", input_type=Int(optional=True), prefix="-w", doc=InputDocumentation(doc="Sum pool width [Default: 128]")), ToolInput(tag="in_proportion_data_validation", input_type=Float(optional=True), prefix="-v", doc=InputDocumentation(doc="Proportion of the data for validation [Default: 0.1]")), ToolInput(tag="in_na", input_type=String(), position=0, doc=InputDocumentation(doc="--umap_t=UMAP_T       Remove sequences with more than this unmappable bin %"))], outputs=[ToolOutput(tag="out_output_directory", output_type=Directory(optional=True), selector=InputSelector(input_to_select="in_output_directory", type_hint=File()), doc=OutputDocumentation(doc="Output directory [Default: align_out]"))], container="quay.io/biocontainers/basenji:0.5.1--pyhdfd78af_0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Basenji_Data_Align_Py_V0_1_0().translate("wdl")

